Subject: Re: linux-next20240208: tg3 driver nw interfaces not getting configured

From: Heiner Kallweit <[email-masked]>
Date: Thu, 8 Feb 2024 15:02:34 +0100

On 08.02.2024 12:05, Aithal, Srikanth wrote:
> On 2/8/2024 4:16 PM, Heiner Kallweit wrote:
>> On 08.02.2024 09:30, Aithal, Srikanth wrote:
>>> Hi,
>>>
>>> On 6.8.0-rc3-next-20240208, the network interfaces are not getting configured.
>>>
>> Thanks for the report. Could you please elaborate on what "not getting
>> configured" means in detail?
>> - Any error in any log?
>> - Any other error message?
>> - Interface doesn't come up or which specific configuration are you missing?
>>
> I am not seeing any errors in the dmesg,
> 
> [    4.019383] tg3 0000:c1:00.0 eth0: Tigon3 [partno(BCM95720) rev 5720000] (PCI Express) MAC address d0:8e:79:bb:95:90
> [    4.019391] tg3 0000:c1:00.0 eth0: attached PHY is 5720C (10/100/1000Base-T Ethernet) (WireSpeed[1], EEE[1])
> [    4.019394] tg3 0000:c1:00.0 eth0: RXcsums[1] LinkChgREG[0] MIirq[0] ASF[1] TSOcap[1]
> [    4.019397] tg3 0000:c1:00.0 eth0: dma_rwctrl[00000001] dma_mask[64-bit]
> [    4.041082] tg3 0000:c1:00.1 eth1: Tigon3 [partno(BCM95720) rev 5720000] (PCI Express) MAC address d0:8e:79:bb:95:91
> [    4.041087] tg3 0000:c1:00.1 eth1: attached PHY is 5720C (10/100/1000Base-T Ethernet) (WireSpeed[1], EEE[1])
> [    4.041090] tg3 0000:c1:00.1 eth1: RXcsums[1] LinkChgREG[0] MIirq[0] ASF[1] TSOcap[1]
> [    4.041092] tg3 0000:c1:00.1 eth1: dma_rwctrl[00000001] dma_mask[64-bit]
> [    4.077483] tg3 0000:c1:00.1 eno8403: renamed from eth1
> [    4.124657] tg3 0000:c1:00.0 eno8303: renamed from eth0
> 
> nmcli says interfaces are disconnected:
> 
> [root@localhost ~]# nmcli
> eno8303: disconnected
>         "Broadcom and subsidiaries NetXtreme BCM5720"
>         ethernet (tg3), D0:8E:79:BB:95:90, hw, mtu 1500
> 
> eno8403: disconnected
>         "Broadcom and subsidiaries NetXtreme BCM5720"
>         ethernet (tg3), D0:8E:79:BB:95:91, hw, mtu 1500
> 
> I am attaching host dmesg.
> 

Thanks. dmesg lists no error. Please send output from the following commands.

ip link
ethtool <if>
ethtool --show-eee <if>

If the interfaces aren't up, please try to bring them up manually and see what happens.
ip link set <if> up

>>> I have 'NetXtreme BCM5720 Gigabit Ethernet PCIe'
>>>         configuration: autonegotiation=on broadcast=yes driver=tg3
>>>
>>> If I revert below commit I am able to get back the interfaces mentioned.
>>>
>>> commit 9bc791341bc9a5c22b94889aa37993bb69faa317
>>> Author: Heiner Kallweit <[email-masked]>
>>> Date:   Sat Feb 3 22:12:50 2024 +0100
>>>
>>>      tg3: convert EEE handling to use linkmode bitmaps
>>>
>>>      Convert EEE handling to use linkmode bitmaps. This prepares for
>>>      removing the legacy bitmaps from struct ethtool_keee.
>>>      No functional change intended.
>>>
>>>      Note: The change to mii_eee_cap1_mod_linkmode_t(tp->eee.advertised, val)
>>>      in tg3_phy_autoneg_cfg() isn't completely obvious, but it doesn't change
>>>      the current functionality.
>>>
>>>      Signed-off-by: Heiner Kallweit <[email-masked]>
>>>      Reviewed-by: Andrew Lunn <[email-masked]>
>>>      Link: https://lore.kernel.org/r/[email-masked]
>>>      Signed-off-by: Jakub Kicinski <[email-masked]>
>>>
>>>
>>> The same works fine on 6.8.0-rc3-next-20240207.
>>>
>>> Thanks,
>>> Srikanth Aithal
>>> [email-masked]
>> Heiner